Subject: RE: [Tsvwg] SCTP Parameter relationships (in RFC2960 12.*)

From: [email-masked]
Date: Wed, 24 Oct 2001 17:01:43 +0300

> Ivan:
> 
> I just finished answering Douglas but I did not
> mention why the peers port is NOT in 12.2 ... but the
> answer is that it IS in 12.2 but hidden :>
> 
> If one looks at:
> "
>    Peer        : A list of SCTP transport addresses that the peer is
>    Transport   : bound to.  This information is derived from 
> the INIT or
>    Address     : INIT ACK and is used to associate an inbound packet
>    List        : with a given association.  Normally this 
> information is
>                : hashed or keyed for quick lookup and access 
> of the TCB.
> "
> 
> One can find the port. This is due to the definition of an SCTP
> transport
> address... which is the combination of an IP address AND a SCTP port!

	Yep! I didn't realize that!

> One can argue that it would have been clearer to seperate this into
> two items but the port IS covered by the defintion of an SCTP 
> transport
> address...

	Well... It appears in 1.4, so... Our mistake... But it is really
little bit tricky, as when one hears "address" immediately thinks in an IP
address and nothing else... :-0

> Oh and adding the local port is an implementation decision trading
> off space versus possibly speed.. In my kernel work we DO NOT hold
> multiple copys of the local port since it does not speed the lookup
> process. We use a two level hash table. The first level gets one
> to the SCTP endpoint... aka the inpcb if you will... the second 
> gets you to the association structure... which includes a backpointer
> to the SCTP endpoint. So consequently I really don't need to copy
> the local port multiple times since it is always availalbe..

	Yes you are right. In my implementation I have it twice, one
implicitly inside the SCTP instance (in the open sockets), and one in the
SCTP association, so when I create the SCTP datagram I directly include the
local port and send it...

> R

	Thanks!

	BR Iván Arias Rodríguez

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg